Type
	ChatRec = Record
		Active      : Boolean
		Name        : String[30]
		Action      : String[40]
		Loc         : String[30]
		Gender      : Char
		Age         : Byte
		Baud        : String[6]
		Invis       : Boolean
		Avail       : Boolean
		InChat      : Boolean
		ChatRoom    : Byte
End

Type
	ChatRoomRec = Record
		Name		: String[40]
		Reserved	: Array [1..128] of Byte
End

Var Chat	: ChatRec
Var ChatRoom: ChatRoomRec

Function ReadChat(N: Byte): Boolean
Var P1	: String
Var B1	: Boolean = False
Var F1	: File
Begin
        P1:=CfgDataPath+'chat'+Int2Str(N)+'.dat'
        If fileExist(P1) Then Begin
                fAssign(F1,P1,66)
                fReset(F1)
                fRead(F1,Chat,SizeOf(Chat))
                fClose(f1)
                B1:=True
        End

        ReadChat:=B1
End

Procedure SaveChat(N: Byte)
Var P1	: String
Var F1	: File
Begin
	P1:=CfgDataPath+'chat'+Int2Str(N)+'.dat'
	fAssign(F1,P1,66)
	fReWrite(F1)
	fWrite(F1,Chat,SizeOf(Chat))
	fClose(f1)
End


Function ReadChatRoom(N: Byte): Boolean
Var P1	: String
Var B1	: Boolean = False
Var F1	: File
Begin
	P1:=CfgDataPath+'chatroom.dat'
	If N > 0 And fileExist(P1) Then Begin
		fAssign(F1,P1,66)
		fReset(F1)
		fSeek(F1,(N-1) * SizeOf(ChatRoom)) 
		If Not fEof(F1) Then
			fRead(F1,ChatRoom,SizeOf(ChatRoom))
		fClose(F1)
		B1:=True
	End
	ReadChatRoom:=B1
End

Procedure SaveChatRoom(N: Byte)
Var P1	: String
Var F1	: File
Begin
	P1:=CfgDataPath+'chatroom.dat'
	fAssign(F1,P1,66)
	fReset(F1)
	fSeek(F1,(N-1) * SizeOf(ChatRoom)) 
	If Not fEof(F1) Then
		fWrite(F1,ChatRoom,SizeOf(ChatRoom))
	fClose(F1)
End
