#!/usr/bin/python

import os, os.path, sys, fnmatch, random, glob
import shutil, time, socket, select, string, struct
from mrc_config import bbsname

bbsdir=os.getcwd()

# Change this info
tempdir= "%s%stemp" % (bbsdir,os.sep)
datadir= "%s%sdata" % (bbsdir,os.sep)
mrcdir = "%s%smrc" % (datadir,os.sep)
chatdats = "%s%schat*.dat" % (datadir,os.sep)


# keep this
client_version="Mystic Relay Chat Client v0.08"

def FillChatRoom():
	crf="%s%schatroom.dat" % (datadir,os.sep)
	cr=open(crf,"rb")
	crt=cr.read(169)
	x=1
	while len(crt) == 169:
		c1=struct.unpack("<b40s128b",crt)
		i=c1[0]
		s=c1[1]
		s=s[:i]
		ChatRoomNames[x]=s
		crt=cr.read(169)
		x=x+1

def ShowAllUsers(mdata):
	cs=mdata.split("~")
	for f in glob.iglob(chatdats):
		if not 'chatroom' in f:
			ct=open(f,'rb') 
			ctdat=ct.read()
			ct.close()
			Active,ChatName,Action,Loc,G1,Age,B1,I1,A1,InChat,ChatRoom=struct.unpack("<?31s41s31scb7s???b",ctdat)
			cnlen,ChatName=struct.unpack("<b30s",ChatName)
			aclen,Action=struct.unpack("<b40s",Action)
			ChatName=ChatName[:cnlen]
			Action=Action[:aclen]
			mrcserver.send("CLIENT~%s~0~%s~%s~0~|07- |10%s |07of |02%s |09: |11%s\n" % (bbsname,cs[0],cs[1],ChatName,bbsname,Action))

def ShowAllChatters(mdata):
	cs=mdata.split("~")
	for f in glob.iglob(chatdats):
		if not 'chatroom' in f:
			ct=open(f,'rb') 
			ctdat=ct.read()
			ct.close()
			Active,ChatName,Action,Loc,G1,Age,B1,I1,A1,InChat,ChatRoom=struct.unpack("<?31s41s31scb7s???b",ctdat)
			cnlen,ChatName=struct.unpack("<b30s",ChatName)
			aclen,Action=struct.unpack("<b40s",Action)
			ChatName=ChatName[:cnlen]
			if InChat:
				Action=ChatRoomNames[ChatRoom]
				mrcserver.send("CLIENT~%s~0~%s~%s~0~|07- |12%s |07of |04%s |07: |08(|07%02d|08) |12%s\n" % (bbsname,cs[0],cs[1],ChatName,bbsname,ChatRoom,Action))

def ShowAllInMyRoom(mdata):
	cs=mdata.split("~")
	FromUser=cs[0]
	FromSite=cs[1]
	FromChan=int(cs[2])
	for f in glob.iglob(chatdats):
		if not 'chatroom' in f:
			ct=open(f,'rb') 
			ctdat=ct.read()
			ct.close()
			Active,ChatName,Action,Loc,G1,Age,B1,I1,A1,InChat,ChatRoom=struct.unpack("<?31s41s31scb7s???b",ctdat)
			cnlen,ChatName=struct.unpack("<b30s",ChatName)
			aclen,Action=struct.unpack("<b40s",Action)
			ChatName=ChatName[:cnlen]
			Action=Action[:aclen]
			if InChat:
				if int(ChatRoom) == int(cs[2]):
					mrcserver.send("CLIENT~%s~0~%s~ALL~%d~|07- |14%s |07of |06%s |07is here with you\n" % (bbsname,FromUser,FromChan,ChatName,bbsname))


def ShowMeConnected(cdata):
	s=cdata.split("~")
	mrcserver.send("ALL~ALL~0~%s~%s~0~|07- |09%s |07is connected\n" % (s[0],s[1],bbsname))

def send_mrc():
	mrcfiles = os.listdir( mrcdir )
	for file in mrcfiles:
		if fnmatch.fnmatch(file,'*.mrc'):
			mrcfile="%s%s%s" % (mrcdir,os.sep,file)
			f = open(mrcfile,"r")
			fl=f.readline()
			while fl:
				mrcserver.send(fl)
				fl=f.readline()
			f.close()
			os.remove(mrcfile)

def deliver_mrc( server_data ):
	r1=random.randint(1,99)
	r2=random.randint(1,99)
	r3=random.randint(1,99)
	r4=random.randint(1,99)
	r5=random.randint(1,99)
	filename = "%02d%02d%02d%02d%02d.mrc" % (r1,r2,r3,r4,r5 )


	for f in glob.iglob(chatdats):
		if not 'chatroom' in f:
			chatfile="%s%schat" % (datadir,os.sep)
			xy=f.replace(chatfile,tempdir)
			xy=xy[:-4]
			inusefile="%s%stchat.inuse" % (xy,os.sep)
			if os.path.isfile(inusefile):
				mrcfile="%s%s%s" % (xy,os.sep,filename)
				openfile=open(mrcfile,"a")
				openfile.write(server_data)
				openfile.close()


if __name__ == "__main__":
	
	if(len(sys.argv) < 3) :
		print "Usage : mrc_client.py hostname port"
		sys.exit()

	host = sys.argv[1]
	port = int(sys.argv[2])

	tocount=0
	readbuffer=""
	ChatRoomNames={}
	FillChatRoom()

	mrcserver = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
	mrcserver.settimeout(2)
	if os.sep == "/":
		mrcserver.getsockopt(socket.SOL_SOCKET, socket.SO_KEEPALIVE,1)
		mrcserver.getsockopt(socket.IPPROTO_TCP, socket.TCP_KEEPIDLE,1)
		mrcserver.getsockopt(socket.IPPROTO_TCP, socket.TCP_KEEPINTVL,3)
		mrcserver.getsockopt(socket.IPPROTO_TCP, socket.TCP_KEEPCNT,5)
	else:
		mrcserver.ioctl(socket.SIO_KEEPALIVE_VALS,(1,10000,3000))

	try :
		mrcserver.connect((host,port))
		mrcserver.send(bbsname)
	except :
		print "Unable to connect"
		sys.exit()

	print "Connected to Mystic Relay Chat host."
	running=1
	mrcserver.send("ALL~ALL~0~ALL~ALL~0~|07- |09%s |07is connected\n" % (bbsname))

	while running == 1 :
		send_mrc()
		if os.sep == "/":
			socket_list = [sys.stdin, mrcserver]
		else:
			socket_list = [mrcserver]
		read_sockets, write_sockets, error_sockets = select.select(socket_list, [], [],0)
		for sock in read_sockets:
			if sock == mrcserver:
				readbuffer=readbuffer+sock.recv(2048)
				tdat=string.split(readbuffer, "\n")
				readbuffer=tdat.pop()

				for data in tdat:
					data=string.rstrip(data)
					if data:
						if "~CLIENT~" in data:
							if "~CHANNEL~" in data:
								ShowAllInMyRoom(data)
							else:
								if "~CHATTING~" in data:
									ShowAllChatters(data)
								else:
									if "~WHOON~" in data:
										ShowAllUsers(data)
									else:
										if "~CONNECTED~" in data:
											ShowMeConnected(data)
						else:
							deliver_mrc(data)
					
			if sock == sys.stdin:
				line=sock.readline()
				if "CQUIT" in line:
					mrcserver.send("ALL~ALL~0~ALL~ALL~0~|07- |02%s |07is disconnected\n" % (bbsname))
					time.sleep(2)
					running=0

		time.sleep(0.25)

	mrcserver.shutdown(2)
	mrcserver.close()
